{% if 'k3s' in cloudstack.stack.plugins %}
kubeApiServer:
  enabled: false
kubeControllerManager:
  enabled: false
kubeScheduler:
  enabled: false
  endpoints:
kubeProxy:
  enabled: false
kubeEtcd:
  enabled: false
{% endif %}

alertmanager:
  alertmanagerSpec:
    resources:
      requests:
        memory: 128Mi
        cpu: 200m
      limits:
        memory: 128Mi
        cpu: 200m
  config:
    global:
      resolve_timeout: 10m
    route:
      routes:
      - match:
          alertname: Watchdog
        receiver: 'null'
{% if cloudstack.plugins.alertmanager.config.receiver == "slack" %}
      - match:
        receiver: 'slack'
        continue: true
{% elif cloudstack.plugins.alertmanager.config.receiver == "webhook" %}
      - match:
        receiver: 'cloudstack-webhook'
        continue: true
{% endif %}
      group_by: ['job']
      group_wait: 30s
      group_interval: 5m
      repeat_interval: 12h
{% if cloudstack.plugins.alertmanager.config.receiver == "slack" %}
      receiver: "slack"
{% elif cloudstack.plugins.alertmanager.config.receiver == "webhook" %}
      receiver: "cloudstack-webhook"
{% else %}
      receiver: 'null'
{% endif %}
    receivers:
    - name: 'null'
{% if cloudstack.plugins.alertmanager.config.receiver == "webhook" %}
    - name: 'cloudstack-webhook'
      webhook_configs:
        - url: "{{ cloudstack.plugins.alertmanager.config.webhook.url }}"
          send_resolved: true
          http_config:
            authorization:
              type: 'Bearer'
              credentials: "{{ cloudstack.plugins.alertmanager.config.webhook.token }}"
{% elif cloudstack.plugins.alertmanager.config.receiver == "slack" %}
    - name: 'slack'
      slack_configs:
      - channel: "{{ cloudstack.plugins.slack.config.channel }}"
        send_resolved: true
        api_url: "{{ cloudstack.plugins.slack.config.api.url }}"
        icon_url: https://avatars3.githubusercontent.com/u/3380462
{% filter indent(width=8) %}
{% raw %}
title: |-
  [{{ .Status | toUpper }}{{ if eq .Status "firing" }}:{{ .Alerts.Firing | len }}{{ end }}] {{ .CommonLabels.alertname }} for {{ .CommonLabels.job }}
  {{- if gt (len .CommonLabels) (len .GroupLabels) -}}
    {{" "}}(
    {{- with .CommonLabels.Remove .GroupLabels.Names }}
      {{- range $index, $label := .SortedPairs -}}
        {{ if $index }}, {{ end }}
        {{- $label.Name }}="{{ $label.Value -}}"
      {{- end }}
    {{- end -}}
    )
  {{- end }}
text: >-
  {{ range .Alerts -}}
  *Alert:* {{ .Annotations.title }}{{ if .Labels.severity }} - `{{ .Labels.severity }}`{{ end }}

  *Description:* {{ .Annotations.description }}

  *Details:*
    {{ range .Labels.SortedPairs }} • *{{ .Name }}:* `{{ .Value }}`
    {{ end }}
  {{ end }}
{% endraw %}
{% endfilter %}
{% endif %}
prometheus:
  prometheusSpec:
    resources:
      requests:
        memory: 500Mi
        cpu: 200m
      limits:
        memory: 999Mi
        cpu: 500m
    serviceMonitorSelectorNilUsesHelmValues: false
    podMonitorSelectorNilUsesHelmValues: false
    probeSelectorNilUsesHelmValues: false
    externalLabels:
      prometheus: "{{ cloudstack.plugins.prometheus.subdomain }}.{{ cloudstack.stack.hostname }}"
      cloudstack_version: "{{ lookup('env', 'CLOUDSTACK_VERSION') | default('development') }}"
{% if cloudstack.plugins.prometheus.config.remote_write.enabled|bool %}
    remoteWrite:
{% filter indent(width=6) %}
      {{ cloudstack.plugins.prometheus.config.remote_write.targets | from_yaml }}
{% endfilter %}
    remoteWriteDashboards: true
{% endif %}

{% if cloudstack.plugins.grafana.enabled|bool %}
grafana:
  plugins:
    - digrich-bubblechart-panel
    - grafana-clock-panel
    - grafana-piechart-panel
    - fifemon-graphql-datasource
  defaultDashboardsTimezone: browser
  adminPassword: "{{ prometheus_admin_credentials.password }}"
  additionalDataSources:
{% if cloudstack.plugins.alertmanager.enabled|bool %}
    - name: Alertmanager
      type: alertmanager
      editable: false
      url: http://prometheus-kube-prometheus-alertmanager.monitoring.svc.cluster.local:9090
      access: proxy
      jsonData:
        implementation: 'prometheus'
{% endif %}
{% if 'loki' in cloudstack.stack.plugins %}
    - name: loki
      type: loki
      isDefault: false
      editable: false
      url: http://loki-headless.loki.svc.cluster.local:3100
      jsonData:
        maxLines: 1000
{% if 'tempo' in cloudstack.stack.plugins %}
        derivedFields:
        - datasourceUid: tempo
          matcherRegex: .*(?:traceID|TraceID|trace_id|TraceId|Activity\.TraceId):\s*(\w+)
          url: '$${__value.raw}'
          name: TraceID
{% endif %}
{% endif %}
{% if 'tempo' in cloudstack.stack.plugins %}
    - name: tempo
      type: tempo
      uid: tempo
      isDefault: false
      editable: false
      #url: http://tempo.tempo.svc.cluster.local:3100
      url: http://tempo-grafana-tempo-query-frontend-headless.tempo.svc.cluster.local:3100
{% endif %}
{% if cloudstack.plugins.grafana.ingress.enabled|bool or cloudstack.stack.exposed|bool %}
  ingress:
    enabled: true
    annotations:
      kubernetes.io/ingress.class: "nginx"
{% if cloudstack.plugins.grafana.ingress.tls.enabled|bool or cloudstack.stack.tls|bool %}
{% if cloudstack.plugins.grafana.ingress.tls.provider == "letsencrypt" %}
      kubernetes.io/tls-acme: "true"
      acme.cert-manager.io/http01-ingress-class: "nginx"
{% if cloudstack.plugins.letsencrypt.config.issuers.dns01.enabled|bool %}
      cert-manager.io/cluster-issuer: "cloudstack-dns01"
{% elif cloudstack.plugins.letsencrypt.config.issuers.http01.enabled|bool %}
      cert-manager.io/cluster-issuer: "letsencrypt-{{ cloudstack.plugins.letsencrypt.config.environment }}"
{% endif %}
{% endif %}
    tls:
      - secretName: "{{ cloudstack.plugins.grafana.ingress.tls.secret.name }}" 
        hosts:
{% if cloudstack.plugins.grafana.ingress.hostname != "" %}
          - "{{ cloudstack.plugins.grafana.ingress.hostname }}"
{% else %}
          - "{{ cloudstack.plugins.grafana.subdomain }}.{{ cloudstack.stack.hostname }}"
{% endif %}
{% endif %}
    hosts:
{% if cloudstack.plugins.grafana.ingress.hostname != "" %}
      - "{{ cloudstack.plugins.grafana.ingress.hostname }}"
{% else %}
      - "{{ cloudstack.plugins.grafana.subdomain }}.{{ cloudstack.stack.hostname }}"
{% endif %}
    path: /
{% endif %}
  grafana.ini:
    plugins:
      enable_alpha: true
      plugin_admin_enabled: true
    server:
      domain: "{{ cloudstack.plugins.grafana.subdomain }}.{{ cloudstack.stack.hostname }}"
      root_url: "{{ ingress_protocol }}://{{ cloudstack.plugins.grafana.subdomain }}.{{ cloudstack.stack.hostname }}/"
{% if 'keycloak' in cloudstack.stack.plugins %}
    # https://grafana.com/docs/grafana/latest/auth/generic-oauth/
    auth:
      disable_login_form: true
      oauth_auto_login: true
    auth.generic_oauth:
      name: "Keycloak"
      enabled: "true"
      allow_sign_up: "true"
      scopes: "openid profile roles"
      auth_url: "{{ ingress_protocol }}://{{ cloudstack.plugins.keycloak.subdomain }}.{{ cloudstack.stack.hostname }}/auth/realms/master/protocol/openid-connect/auth"
      token_url: "{{ ingress_protocol }}://{{ cloudstack.plugins.keycloak.subdomain }}.{{ cloudstack.stack.hostname }}/auth/realms/master/protocol/openid-connect/token"
      api_url: "{{ ingress_protocol }}://{{ cloudstack.plugins.keycloak.subdomain }}.{{ cloudstack.stack.hostname }}/auth/realms/master/protocol/openid-connect/userinfo"
      team_ids:
      allowed_organizations:
      client_id: "grafana"
      client_secret: "{{ keycloak_client_secret_value }}"
      #role_attribute_path: "contains(roles[*], 'admin') && 'Admin' || contains(roles[*], 'editor') && 'Editor' || 'Viewer'"
      role_attribute_path: "contains(resource_access.grafana.roles[*], 'admin') && 'Admin' || contains(resource_access.grafana.roles[*], 'editor') && 'Editor' || 'Viewer'"
      #role_attribute_path: resource_access.grafana.roles[0]
{% endif %}
{% endif %}
prometheus-node-exporter:
  tolerations:
    - operator: Exists
      effect: NoExecute
    - operator: Exists
      effect: NoSchedule
    - key: CriticalAddonsOnly
      operator: Exists
      effect: NoSchedule
    - key: CriticalAddonsOnly
      operator: Exists
      effect: NoExecute
  resources:
    limits:
      cpu: 200m
      memory: 128Mi
    requests:
      cpu: 100m
      memory: 30Mi